# bandt-pompe permutation and entropy

This python package is able to calculate the ordinal pattern representation and the entropy based on those patterns on time series according to:
https://pdfs.semanticscholar.org/04de/9ce062c6ac999fa009b9c264da20a8d8a282.pdf

## Requirements
* in order to install requirements use `pip3 install -r requirements.txt`

## Usage

### first possibility
* use `python3 data_processing.py <file> <timelag> <gap> <windowsize> [-l | -r] [-v]` (see also `python3 data_processing.py -h`)
* `<file>` is the path of the input data file (should be csv)
* `<timelag>` specifies the length of produced ordinal patterns
* `<gap>` specifies gap between subsequent values that are used for creating temporal patterns
* `<windowsize>` is the size of the sliding window used for entropy calculation
* `-r` for using range normalization of entropy to interval [0, 1] (default) or `-l` for using linear normalization
* `-v` for additional output like duration of calculations and output files

### second possibility
* include `import data_processing` in your python file
* call `data_processing(file_path, timelag, gap, windowsize, normalization, verbose)`

### third possibility
* directly include the necessary functions from `bandt_pompe.bandt_pompe` and `bandt_pompe.entropy_calculation` (see data_processing.py)

## Visualization of results
* for visualization one can just copy the jupyter notebook and change the given paths 
