import numpy as np
import pandas as pd
from bandt_pompe.ordinal_patterns_calculation import calculate_permutations,\
    calculate_ordinal_patterns, decode
import unittest


class Test_ordinal_patterns_calculation(unittest.TestCase):

    def test_calculate_ordinal_patterns(self):
        gap = 1
        timelag = 3
        input_df = pd.DataFrame({'Col1': [1, 2, 3, 5, 4, 0, 1, 2]})
        expected_ordinal = pd.DataFrame({'Col1': [21, 11, 11, 7]})
        expected_short = pd.DataFrame({'Col1': [4, 0, 1, 2]})
        short, ordinal = calculate_ordinal_patterns(input_df, timelag, gap)
        self.assertTrue((expected_ordinal == ordinal).all().all())
        self.assertTrue((expected_short == short).all().all())

    def test_decode(self):
        gap = 1
        timelag = 3
        expected = np.array([[0, 1, 2], [2, 0, 1], [2, 0, 1], [1, 2, 0]])
        input_array = np.array([21, 11, 11, 7])
        result = decode(input_array, timelag)
        self.assertTrue((expected == result).all().all())


if __name__ == '__main__':
    unittest.main()
