import numpy as np
import pandas as pd
from bandt_pompe.scaling import scale_dataframe
import unittest


class Test_scaling(unittest.TestCase):

    def test_scale_dataframe(self):
        f1 = np.arange(13)
        t = np.array(([1]*6) + ([0]*7))
        input_data = pd.DataFrame({'f1': f1, 't': t})
        expected = pd.DataFrame({'f1': [1.5, 5.5, 9.5], 't': [1, 0, 0]})

        result = scale_dataframe(input_data, 4, 't')
        self.assertTrue((expected == result).all().all())


if __name__ == '__main__':
    unittest.main()
